Index: uspace/drv/hid/usbhid/kbd/kbddev.c
===================================================================
--- uspace/drv/hid/usbhid/kbd/kbddev.c	(revision 2752620b090f5bf0ecc3baace21dc1fa5da89d73)
+++ uspace/drv/hid/usbhid/kbd/kbddev.c	(revision 2b3dd78e52704a51e22b71513327373cf8f6a614)
@@ -185,8 +185,8 @@
 		if (kbd_dev->client_sess == NULL) {
 			kbd_dev->client_sess = sess;
-			usb_log_debug("%s: OK\n", __FUNCTION__);
+			usb_log_debug("%s: OK", __FUNCTION__);
 			async_answer_0(icallid, EOK);
 		} else {
-			usb_log_error("%s: console session already set\n",
+			usb_log_error("%s: console session already set",
 			   __FUNCTION__);
 			async_answer_0(icallid, ELIMIT);
@@ -195,5 +195,5 @@
 	}
 	default:
-			usb_log_error("%s: Unknown method: %d.\n",
+			usb_log_error("%s: Unknown method: %d.",
 			    __FUNCTION__, (int) method);
 			async_answer_0(icallid, EINVAL);
@@ -226,5 +226,5 @@
 	/* Reset the LED data. */
 	memset(kbd_dev->led_data, 0, kbd_dev->led_output_size * sizeof(int32_t));
-	usb_log_debug("Creating output report:\n");
+	usb_log_debug("Creating output report:");
 
 	usb_hid_report_field_t *field = usb_hid_report_get_sibling(
@@ -266,5 +266,5 @@
 	}
 
-	usb_log_debug("Output report buffer: %s\n",
+	usb_log_debug("Output report buffer: %s",
 	    usb_debug_str_buffer(kbd_dev->output_buffer, kbd_dev->output_size,
 	        0));
@@ -276,5 +276,5 @@
 	    kbd_dev->output_buffer, kbd_dev->output_size);
 	if (rc != EOK) {
-		usb_log_warning("Failed to set kbd indicators.\n");
+		usb_log_warning("Failed to set kbd indicators.");
 	}
 }
@@ -289,5 +289,5 @@
 void usb_kbd_push_ev(usb_kbd_t *kbd_dev, int type, unsigned key)
 {
-	usb_log_debug2("Sending kbdev event %d/%d to the console\n", type, key);
+	usb_log_debug2("Sending kbdev event %d/%d to the console", type, key);
 	if (kbd_dev->client_sess == NULL) {
 		usb_log_warning(
@@ -301,5 +301,5 @@
 		async_exchange_end(exch);
 	} else {
-		usb_log_warning("Failed to send key to console.\n");
+		usb_log_warning("Failed to send key to console.");
 	}
 }
@@ -328,9 +328,9 @@
  * An event is created only when key is pressed or released. Besides handling
  * the events (usb_kbd_push_ev()), the auto-repeat fibril is notified about
- * key presses and releases (see usb_kbd_repeat_start() and 
+ * key presses and releases (see usb_kbd_repeat_start() and
  * usb_kbd_repeat_stop()).
  *
  * @param kbd_dev Keyboard device structure.
- * @param key_codes Parsed keyboard report - codes of currently pressed keys 
+ * @param key_codes Parsed keyboard report - codes of currently pressed keys
  *                  according to HID Usage Tables.
  * @param count Number of key codes in report (size of the report).
@@ -353,5 +353,5 @@
 	    kbd_dev->key_count);
 	if (i != (size_t) -1) {
-		usb_log_error("Detected phantom state.\n");
+		usb_log_error("Detected phantom state.");
 		return;
 	}
@@ -403,5 +403,5 @@
 	ddf_dump_buffer(key_buffer, 512,
 	    kbd_dev->keys_old, 4, kbd_dev->key_count, 0);
-	usb_log_debug2("Stored keys %s.\n", key_buffer);
+	usb_log_debug2("Stored keys %s.", key_buffer);
 }
 
@@ -431,5 +431,5 @@
 	usb_hid_report_path_t *path = usb_hid_report_path();
 	if (path == NULL) {
-		usb_log_error("Failed to create hid/kbd report path.\n");
+		usb_log_error("Failed to create hid/kbd report path.");
 		return;
 	}
@@ -438,5 +438,5 @@
 	   usb_hid_report_path_append_item(path, USB_HIDUT_PAGE_KEYBOARD, 0);
 	if (ret != EOK) {
-		usb_log_error("Failed to append to hid/kbd report path.\n");
+		usb_log_error("Failed to append to hid/kbd report path.");
 		return;
 	}
@@ -452,5 +452,5 @@
 
 	while (field != NULL) {
-		usb_log_debug2("FIELD (%p) - VALUE(%d) USAGE(%u)\n",
+		usb_log_debug2("FIELD (%p) - VALUE(%d) USAGE(%u)",
 		    field, field->value, field->usage);
 
@@ -464,5 +464,5 @@
 			kbd_dev->keys[i] = 0;
 		}
-		usb_log_debug2("Saved %u. key usage %d\n", i, kbd_dev->keys[i]);
+		usb_log_debug2("Saved %u. key usage %d", i, kbd_dev->keys[i]);
 
 		++i;
@@ -502,5 +502,5 @@
 	usb_hid_report_path_t *path = usb_hid_report_path();
 	if (path == NULL) {
-		usb_log_error("Failed to create kbd report path.\n");
+		usb_log_error("Failed to create kbd report path.");
 		usb_kbd_destroy(kbd_dev);
 		return ENOMEM;
@@ -510,5 +510,5 @@
 	    usb_hid_report_path_append_item(path, USB_HIDUT_PAGE_KEYBOARD, 0);
 	if (ret != EOK) {
-		usb_log_error("Failed to append item to kbd report path.\n");
+		usb_log_error("Failed to append item to kbd report path.");
 		usb_hid_report_path_free(path);
 		usb_kbd_destroy(kbd_dev);
@@ -523,9 +523,9 @@
 	usb_hid_report_path_free(path);
 
-	usb_log_debug("Size of the input report: %zu\n", kbd_dev->key_count);
+	usb_log_debug("Size of the input report: %zu", kbd_dev->key_count);
 
 	kbd_dev->keys = calloc(kbd_dev->key_count, sizeof(int32_t));
 	if (kbd_dev->keys == NULL) {
-		usb_log_error("Failed to allocate key buffer.\n");
+		usb_log_error("Failed to allocate key buffer.");
 		usb_kbd_destroy(kbd_dev);
 		return ENOMEM;
@@ -534,5 +534,5 @@
 	kbd_dev->keys_old = calloc(kbd_dev->key_count, sizeof(int32_t));
 	if (kbd_dev->keys_old == NULL) {
-		usb_log_error("Failed to allocate old_key buffer.\n");
+		usb_log_error("Failed to allocate old_key buffer.");
 		usb_kbd_destroy(kbd_dev);
 		return ENOMEM;
@@ -544,14 +544,14 @@
 	    &kbd_dev->output_size, 0);
 	if (kbd_dev->output_buffer == NULL) {
-		usb_log_error("Error creating output report buffer.\n");
+		usb_log_error("Error creating output report buffer.");
 		usb_kbd_destroy(kbd_dev);
 		return ENOMEM;
 	}
 
-	usb_log_debug("Output buffer size: %zu\n", kbd_dev->output_size);
+	usb_log_debug("Output buffer size: %zu", kbd_dev->output_size);
 
 	kbd_dev->led_path = usb_hid_report_path();
 	if (kbd_dev->led_path == NULL) {
-		usb_log_error("Failed to create kbd led report path.\n");
+		usb_log_error("Failed to create kbd led report path.");
 		usb_kbd_destroy(kbd_dev);
 		return ENOMEM;
@@ -561,5 +561,5 @@
 	    kbd_dev->led_path, USB_HIDUT_PAGE_LED, 0);
 	if (ret != EOK) {
-		usb_log_error("Failed to append to kbd/led report path.\n");
+		usb_log_error("Failed to append to kbd/led report path.");
 		usb_kbd_destroy(kbd_dev);
 		return ret;
@@ -569,10 +569,10 @@
 	    &hid_dev->report, 0, USB_HID_REPORT_TYPE_OUTPUT);
 
-	usb_log_debug("Output report size (in items): %zu\n",
+	usb_log_debug("Output report size (in items): %zu",
 	    kbd_dev->led_output_size);
 
 	kbd_dev->led_data = calloc(kbd_dev->led_output_size, sizeof(int32_t));
 	if (kbd_dev->led_data == NULL) {
-		usb_log_error("Error creating buffer for LED output report.\n");
+		usb_log_error("Error creating buffer for LED output report.");
 		usb_kbd_destroy(kbd_dev);
 		return ENOMEM;
@@ -588,5 +588,5 @@
 
 	kbd_dev->initialized = USB_KBD_STATUS_INITIALIZED;
-	usb_log_debug("HID/KBD device structure initialized.\n");
+	usb_log_debug("HID/KBD device structure initialized.");
 
 	return EOK;
@@ -618,5 +618,5 @@
 errno_t usb_kbd_init(usb_hid_dev_t *hid_dev, void **data)
 {
-	usb_log_debug("Initializing HID/KBD structure...\n");
+	usb_log_debug("Initializing HID/KBD structure...");
 
 	if (hid_dev == NULL) {
@@ -627,9 +627,9 @@
 
 	/* Create the exposed function. */
-	usb_log_debug("Creating DDF function %s...\n", HID_KBD_FUN_NAME);
+	usb_log_debug("Creating DDF function %s...", HID_KBD_FUN_NAME);
 	ddf_fun_t *fun = usb_device_ddf_fun_create(hid_dev->usb_dev,
 	    fun_exposed, HID_KBD_FUN_NAME);
 	if (fun == NULL) {
-		usb_log_error("Could not create DDF function node.\n");
+		usb_log_error("Could not create DDF function node.");
 		return ENOMEM;
 	}
@@ -637,5 +637,5 @@
 	usb_kbd_t *kbd_dev = ddf_fun_data_alloc(fun, sizeof(usb_kbd_t));
 	if (kbd_dev == NULL) {
-		usb_log_error("Failed to allocate KBD device structure.\n");
+		usb_log_error("Failed to allocate KBD device structure.");
 		ddf_fun_destroy(fun);
 		return ENOMEM;
@@ -644,5 +644,5 @@
 	errno_t ret = kbd_dev_init(kbd_dev, hid_dev);
 	if (ret != EOK) {
-		usb_log_error("Failed to initialize KBD device  structure.\n");
+		usb_log_error("Failed to initialize KBD device  structure.");
 		ddf_fun_destroy(fun);
 		return ret;
@@ -655,5 +655,5 @@
 	ret = ddf_fun_bind(fun);
 	if (ret != EOK) {
-		usb_log_error("Could not bind DDF function: %s.\n",
+		usb_log_error("Could not bind DDF function: %s.",
 		    str_error(ret));
 		usb_kbd_destroy(kbd_dev);
@@ -662,8 +662,8 @@
 	}
 
-	usb_log_debug("%s function created. Handle: %" PRIun "\n",
+	usb_log_debug("%s function created. Handle: %" PRIun "",
 	    HID_KBD_FUN_NAME, ddf_fun_get_handle(fun));
 
-	usb_log_debug("Adding DDF function to category %s...\n",
+	usb_log_debug("Adding DDF function to category %s...",
 	    HID_KBD_CATEGORY_NAME);
 	ret = ddf_fun_add_to_category(fun, HID_KBD_CATEGORY_NAME);
@@ -709,4 +709,5 @@
 	usb_kbd_process_data(hid_dev, kbd_dev);
 
+	/* Continue polling until the device is about to be removed. */
 	return true;
 }
@@ -752,8 +753,8 @@
 	if (kbd_dev->fun) {
 		if (ddf_fun_unbind(kbd_dev->fun) != EOK) {
-			usb_log_warning("Failed to unbind %s.\n",
+			usb_log_warning("Failed to unbind %s.",
 			    ddf_fun_get_name(kbd_dev->fun));
 		} else {
-			usb_log_debug2("%s unbound.\n",
+			usb_log_debug2("%s unbound.",
 			    ddf_fun_get_name(kbd_dev->fun));
 			ddf_fun_destroy(kbd_dev->fun);
@@ -783,5 +784,5 @@
 
 	if (rc != EOK) {
-		usb_log_error("Failed to parse boot report descriptor: %s\n",
+		usb_log_error("Failed to parse boot report descriptor: %s",
 		    str_error(rc));
 		return rc;
Index: uspace/drv/hid/usbhid/kbd/kbdrepeat.c
===================================================================
--- uspace/drv/hid/usbhid/kbd/kbdrepeat.c	(revision 2752620b090f5bf0ecc3baace21dc1fa5da89d73)
+++ uspace/drv/hid/usbhid/kbd/kbdrepeat.c	(revision 2b3dd78e52704a51e22b71513327373cf8f6a614)
@@ -69,10 +69,10 @@
 	unsigned int delay = 0;
 
-	usb_log_debug("Starting autorepeat loop.\n");
+	usb_log_debug("Starting autorepeat loop.");
 
 	while (true) {
 		/* Check if the kbd structure is usable. */
 		if (!usb_kbd_is_initialized(kbd)) {
-			usb_log_warning("kbd not ready, exiting autorepeat.\n");
+			usb_log_warning("kbd not ready, exiting autorepeat.");
 			return;
 		}
@@ -82,5 +82,5 @@
 		if (kbd->repeat.key_new > 0) {
 			if (kbd->repeat.key_new == kbd->repeat.key_repeated) {
-				usb_log_debug2("Repeating key: %u.\n",
+				usb_log_debug2("Repeating key: %u.",
 				    kbd->repeat.key_repeated);
 				usb_kbd_push_ev(kbd, KEY_PRESS,
@@ -88,5 +88,5 @@
 				delay = kbd->repeat.delay_between;
 			} else {
-				usb_log_debug2("New key to repeat: %u.\n",
+				usb_log_debug2("New key to repeat: %u.",
 				    kbd->repeat.key_new);
 				kbd->repeat.key_repeated = kbd->repeat.key_new;
@@ -95,5 +95,5 @@
 		} else {
 			if (kbd->repeat.key_repeated > 0) {
-				usb_log_debug2("Stopping to repeat key: %u.\n",
+				usb_log_debug2("Stopping to repeat key: %u.",
 				    kbd->repeat.key_repeated);
 				kbd->repeat.key_repeated = 0;
@@ -119,8 +119,8 @@
 errno_t usb_kbd_repeat_fibril(void *arg)
 {
-	usb_log_debug("Autorepeat fibril spawned.\n");
+	usb_log_debug("Autorepeat fibril spawned.");
 
 	if (arg == NULL) {
-		usb_log_error("No device!\n");
+		usb_log_error("No device!");
 		return EINVAL;
 	}
Index: uspace/drv/hid/usbhid/main.c
===================================================================
--- uspace/drv/hid/usbhid/main.c	(revision 2752620b090f5bf0ecc3baace21dc1fa5da89d73)
+++ uspace/drv/hid/usbhid/main.c	(revision 2b3dd78e52704a51e22b71513327373cf8f6a614)
@@ -58,8 +58,8 @@
 static errno_t usb_hid_device_add(usb_device_t *dev)
 {
-	usb_log_debug("%s\n", __FUNCTION__);
+	usb_log_debug("%s", __FUNCTION__);
 
 	if (dev == NULL) {
-		usb_log_error("Wrong parameter given for add_device().\n");
+		usb_log_error("Wrong parameter given for add_device().");
 		return EINVAL;
 	}
@@ -73,5 +73,5 @@
 	    usb_device_data_alloc(dev, sizeof(usb_hid_dev_t));
 	if (hid_dev == NULL) {
-		usb_log_error("Failed to create USB/HID device structure.\n");
+		usb_log_error("Failed to create USB/HID device structure.");
 		return ENOMEM;
 	}
@@ -79,30 +79,18 @@
 	errno_t rc = usb_hid_init(hid_dev, dev);
 	if (rc != EOK) {
-		usb_log_error("Failed to initialize USB/HID device.\n");
+		usb_log_error("Failed to initialize USB/HID device.");
 		usb_hid_deinit(hid_dev);
 		return rc;
 	}
 
-	usb_log_debug("USB/HID device structure initialized.\n");
+	usb_log_debug("USB/HID device structure initialized.");
 
 	/* Start automated polling function.
 	 * This will create a separate fibril that will query the device
 	 * for the data continuously. */
-	rc = usb_device_auto_poll_desc(dev,
-	   /* Index of the polling pipe. */
-	   hid_dev->poll_pipe_mapping->description,
-	   /* Callback when data arrives. */
-	   usb_hid_polling_callback,
-	   /* How much data to request. */
-	   hid_dev->poll_pipe_mapping->pipe.max_packet_size,
-	   /* Delay */
-	   -1,
-	   /* Callback when the polling ends. */
-	   usb_hid_polling_ended_callback,
-	   /* Custom argument. */
-	   hid_dev);
+	rc = usb_polling_start(&hid_dev->polling);
 
 	if (rc != EOK) {
-		usb_log_error("Failed to start polling fibril for `%s'.\n",
+		usb_log_error("Failed to start polling fibril for `%s'.",
 		    usb_device_get_name(dev));
 		usb_hid_deinit(hid_dev);
@@ -111,5 +99,21 @@
 	hid_dev->running = true;
 
-	usb_log_info("HID device `%s' ready.\n", usb_device_get_name(dev));
+	usb_log_info("HID device `%s' ready.", usb_device_get_name(dev));
+
+	return EOK;
+}
+
+static int join_and_clean(usb_device_t *dev)
+{
+	assert(dev);
+	usb_hid_dev_t *hid_dev = usb_device_data_get(dev);
+	assert(hid_dev);
+
+	/* Join polling fibril (ignoring error code). */
+	usb_polling_join(&hid_dev->polling);
+
+	/* Clean up. */
+	usb_hid_deinit(hid_dev);
+	usb_log_info("%s destruction complete.", usb_device_get_name(dev));
 
 	return EOK;
@@ -122,9 +126,12 @@
  * @return Error code.
  */
-static errno_t usb_hid_device_rem(usb_device_t *dev)
+static errno_t usb_hid_device_remove(usb_device_t *dev)
 {
-	// TODO: Stop device polling
-	// TODO: Call deinit (stops autorepeat too)
-	return ENOTSUP;
+	assert(dev);
+	usb_hid_dev_t *hid_dev = usb_device_data_get(dev);
+	assert(hid_dev);
+
+	usb_log_info("Device %s removed.", usb_device_get_name(dev));
+	return join_and_clean(dev);
 }
 
@@ -140,17 +147,7 @@
 	usb_hid_dev_t *hid_dev = usb_device_data_get(dev);
 	assert(hid_dev);
-	unsigned tries = 100;
-	/* Wait for fail. */
-	while (hid_dev->running && tries--) {
-		async_usleep(100000);
-	}
-	if (hid_dev->running) {
-		usb_log_error("Can't remove hid, still running.\n");
-		return EBUSY;
-	}
 
-	usb_hid_deinit(hid_dev);
-	usb_log_debug2("%s destruction complete.\n", usb_device_get_name(dev));
-	return EOK;
+	usb_log_info("Device %s gone.", usb_device_get_name(dev));
+	return join_and_clean(dev);
 }
 
@@ -158,5 +155,5 @@
 static const usb_driver_ops_t usb_hid_driver_ops = {
 	.device_add = usb_hid_device_add,
-	.device_rem = usb_hid_device_rem,
+	.device_remove = usb_hid_device_remove,
 	.device_gone = usb_hid_device_gone,
 };
Index: uspace/drv/hid/usbhid/mouse/mousedev.c
===================================================================
--- uspace/drv/hid/usbhid/mouse/mousedev.c	(revision 2752620b090f5bf0ecc3baace21dc1fa5da89d73)
+++ uspace/drv/hid/usbhid/mouse/mousedev.c	(revision 2b3dd78e52704a51e22b71513327373cf8f6a614)
@@ -118,11 +118,11 @@
 
 	if (mouse_dev == NULL) {
-		usb_log_debug("%s: Missing parameters.\n", __FUNCTION__);
+		usb_log_debug("%s: Missing parameters.", __FUNCTION__);
 		async_answer_0(icallid, EINVAL);
 		return;
 	}
 
-	usb_log_debug("%s: fun->name: %s\n", __FUNCTION__, ddf_fun_get_name(fun));
-	usb_log_debug("%s: mouse_sess: %p\n",
+	usb_log_debug("%s: fun->name: %s", __FUNCTION__, ddf_fun_get_name(fun));
+	usb_log_debug("%s: mouse_sess: %p",
 	    __FUNCTION__, mouse_dev->mouse_sess);
 
@@ -132,9 +132,9 @@
 		if (mouse_dev->mouse_sess == NULL) {
 			mouse_dev->mouse_sess = sess;
-			usb_log_debug("Console session to %s set ok (%p).\n",
+			usb_log_debug("Console session to %s set ok (%p).",
 			    ddf_fun_get_name(fun), sess);
 			async_answer_0(icallid, EOK);
 		} else {
-			usb_log_error("Console session to %s already set.\n",
+			usb_log_error("Console session to %s already set.",
 			    ddf_fun_get_name(fun));
 			async_answer_0(icallid, ELIMIT);
@@ -142,14 +142,12 @@
 		}
 	} else {
-		usb_log_debug("%s: Invalid function.\n", __FUNCTION__);
+		usb_log_debug("%s: Invalid function.", __FUNCTION__);
 		async_answer_0(icallid, EINVAL);
 	}
 }
 
-static int get_mouse_axis_move_value(uint8_t rid, usb_hid_report_t *report,
+static const usb_hid_report_field_t *get_mouse_axis_move_field(uint8_t rid, usb_hid_report_t *report,
     int32_t usage)
 {
-	int result = 0;
-
 	usb_hid_report_path_t *path = usb_hid_report_path();
 	usb_hid_report_path_append_item(path, USB_HIDUT_PAGE_GENERIC_DESKTOP,
@@ -158,18 +156,14 @@
 	usb_hid_report_path_set_report_id(path, rid);
 
-	usb_hid_report_field_t *field = usb_hid_report_get_sibling(
+	const usb_hid_report_field_t *field = usb_hid_report_get_sibling(
 	    report, NULL, path, USB_HID_PATH_COMPARE_END,
 	    USB_HID_REPORT_TYPE_INPUT);
 
-	if (field != NULL) {
-		result = field->value;
-	}
-
 	usb_hid_report_path_free(path);
 
-	return result;
-}
-
-static bool usb_mouse_process_report(usb_hid_dev_t *hid_dev,
+	return field;
+}
+
+static void usb_mouse_process_report(usb_hid_dev_t *hid_dev,
     usb_mouse_t *mouse_dev)
 {
@@ -177,21 +171,51 @@
 
 	if (mouse_dev->mouse_sess == NULL) {
-		usb_log_warning(NAME " No console session.\n");
-		return true;
-	}
-
-	const int shift_x = get_mouse_axis_move_value(hid_dev->report_id,
-	    &hid_dev->report, USB_HIDUT_USAGE_GENERIC_DESKTOP_X);
-	const int shift_y = get_mouse_axis_move_value(hid_dev->report_id,
-	    &hid_dev->report, USB_HIDUT_USAGE_GENERIC_DESKTOP_Y);
-	const int wheel = get_mouse_axis_move_value(hid_dev->report_id,
-	    &hid_dev->report, USB_HIDUT_USAGE_GENERIC_DESKTOP_WHEEL);
-
-	if (shift_x || shift_y || wheel) {
+		usb_log_warning(NAME " No console session.");
+		return;
+	}
+
+	const usb_hid_report_field_t *move_x = get_mouse_axis_move_field(
+	    hid_dev->report_id, &hid_dev->report,
+	    USB_HIDUT_USAGE_GENERIC_DESKTOP_X);
+	const usb_hid_report_field_t *move_y = get_mouse_axis_move_field(
+	    hid_dev->report_id, &hid_dev->report,
+	    USB_HIDUT_USAGE_GENERIC_DESKTOP_Y);
+	const usb_hid_report_field_t *wheel= get_mouse_axis_move_field(
+	    hid_dev->report_id, &hid_dev->report,
+	    USB_HIDUT_USAGE_GENERIC_DESKTOP_WHEEL);
+
+	bool absolute_x = move_x && !USB_HID_ITEM_FLAG_RELATIVE(move_x->item_flags);
+	bool absolute_y = move_y && !USB_HID_ITEM_FLAG_RELATIVE(move_y->item_flags);
+
+	/* Tablet shall always report both X and Y */
+	if (absolute_x != absolute_y) {
+		usb_log_error(NAME " cannot handle mix of absolute and relative mouse move.");
+		return;
+	}
+
+	int shift_x = move_x ? move_x->value : 0;
+	int shift_y = move_y ? move_y->value : 0;
+	int shift_z =  wheel ?  wheel->value : 0;
+
+	if (absolute_x && absolute_y) {
+		async_exch_t *exch =
+		    async_exchange_begin(mouse_dev->mouse_sess);
+		if (exch != NULL) {
+			async_msg_4(exch, MOUSEEV_ABS_MOVE_EVENT,
+			    shift_x, shift_y, move_x->logical_maximum, move_y->logical_maximum);
+			async_exchange_end(exch);
+		}
+
+		// Even if we move the mouse absolutely, we need to resolve wheel
+		shift_x = shift_y = 0;
+	}
+
+
+	if (shift_x || shift_y || shift_z) {
 		async_exch_t *exch =
 		    async_exchange_begin(mouse_dev->mouse_sess);
 		if (exch != NULL) {
 			async_msg_3(exch, MOUSEEV_MOVE_EVENT,
-			    shift_x, shift_y, wheel);
+			    shift_x, shift_y, shift_z);
 			async_exchange_end(exch);
 		}
@@ -201,6 +225,6 @@
 	usb_hid_report_path_t *path = usb_hid_report_path();
 	if (path == NULL) {
-		usb_log_warning("Failed to create USB HID report path.\n");
-		return true;
+		usb_log_warning("Failed to create USB HID report path.");
+		return;
 	}
 	errno_t ret =
@@ -208,6 +232,6 @@
 	if (ret != EOK) {
 		usb_hid_report_path_free(path);
-		usb_log_warning("Failed to add buttons to report path.\n");
-		return true;
+		usb_log_warning("Failed to add buttons to report path.");
+		return;
 	}
 	usb_hid_report_path_set_report_id(path, hid_dev->report_id);
@@ -218,5 +242,5 @@
 
 	while (field != NULL) {
-		usb_log_debug2(NAME " VALUE(%X) USAGE(%X)\n", field->value,
+		usb_log_debug2(NAME " VALUE(%X) USAGE(%X)", field->value,
 		    field->usage);
 		assert(field->usage > field->usage_minimum);
@@ -242,6 +266,4 @@
 
 	usb_hid_report_path_free(path);
-
-	return true;
 }
 
@@ -309,5 +331,5 @@
 
 	if (mouse_dev->buttons == NULL) {
-		usb_log_error(NAME ": out of memory, giving up on device!\n");
+		usb_log_error(NAME ": out of memory, giving up on device!");
 		free(mouse_dev);
 		return ENOMEM;
@@ -322,5 +344,5 @@
 errno_t usb_mouse_init(usb_hid_dev_t *hid_dev, void **data)
 {
-	usb_log_debug("Initializing HID/Mouse structure...\n");
+	usb_log_debug("Initializing HID/Mouse structure...");
 
 	if (hid_dev == NULL) {
@@ -331,9 +353,9 @@
 
 	/* Create the exposed function. */
-	usb_log_debug("Creating DDF function %s...\n", HID_MOUSE_FUN_NAME);
+	usb_log_debug("Creating DDF function %s...", HID_MOUSE_FUN_NAME);
 	ddf_fun_t *fun = usb_device_ddf_fun_create(hid_dev->usb_dev,
 	    fun_exposed, HID_MOUSE_FUN_NAME);
 	if (fun == NULL) {
-		usb_log_error("Could not create DDF function node `%s'.\n",
+		usb_log_error("Could not create DDF function node `%s'.",
 		    HID_MOUSE_FUN_NAME);
 		return ENOMEM;
@@ -342,5 +364,5 @@
 	usb_mouse_t *mouse_dev = ddf_fun_data_alloc(fun, sizeof(usb_mouse_t));
 	if (mouse_dev == NULL) {
-		usb_log_error("Failed to alloc HID mouse device structure.\n");
+		usb_log_error("Failed to alloc HID mouse device structure.");
 		ddf_fun_destroy(fun);
 		return ENOMEM;
@@ -349,5 +371,5 @@
 	errno_t ret = mouse_dev_init(mouse_dev, hid_dev);
 	if (ret != EOK) {
-		usb_log_error("Failed to init HID mouse device structure.\n");
+		usb_log_error("Failed to init HID mouse device structure.");
 		return ret;
 	}
@@ -357,5 +379,5 @@
 	ret = ddf_fun_bind(fun);
 	if (ret != EOK) {
-		usb_log_error("Could not bind DDF function `%s': %s.\n",
+		usb_log_error("Could not bind DDF function `%s': %s.",
 		    ddf_fun_get_name(fun), str_error(ret));
 		ddf_fun_destroy(fun);
@@ -363,5 +385,5 @@
 	}
 
-	usb_log_debug("Adding DDF function `%s' to category %s...\n",
+	usb_log_debug("Adding DDF function `%s' to category %s...",
 	    ddf_fun_get_name(fun), HID_MOUSE_CATEGORY);
 	ret = ddf_fun_add_to_category(fun, HID_MOUSE_CATEGORY);
@@ -390,6 +412,8 @@
 
 	usb_mouse_t *mouse_dev = data;
-
-	return usb_mouse_process_report(hid_dev, mouse_dev);
+	usb_mouse_process_report(hid_dev, mouse_dev);
+
+	/* Continue polling until the device is about to be removed. */
+	return true;
 }
 
@@ -420,5 +444,5 @@
 
 	if (rc != EOK) {
-		usb_log_error("Failed to parse boot report descriptor: %s\n",
+		usb_log_error("Failed to parse boot report descriptor: %s",
 		    str_error(rc));
 		return rc;
Index: uspace/drv/hid/usbhid/multimedia/multimedia.c
===================================================================
--- uspace/drv/hid/usbhid/multimedia/multimedia.c	(revision 2752620b090f5bf0ecc3baace21dc1fa5da89d73)
+++ uspace/drv/hid/usbhid/multimedia/multimedia.c	(revision 2b3dd78e52704a51e22b71513327373cf8f6a614)
@@ -86,5 +86,5 @@
     ipc_callid_t icallid, ipc_call_t *icall)
 {
-	usb_log_debug(NAME " default_connection_handler()\n");
+	usb_log_debug(NAME " default_connection_handler()");
 
 	usb_multimedia_t *multim_dev = ddf_fun_data_get(fun);
@@ -95,5 +95,5 @@
 		if (multim_dev->console_sess == NULL) {
 			multim_dev->console_sess = sess;
-			usb_log_debug(NAME " Saved session to console: %p\n",
+			usb_log_debug(NAME " Saved session to console: %p",
 			    sess);
 			async_answer_0(icallid, EOK);
@@ -137,5 +137,5 @@
 	};
 
-	usb_log_debug2(NAME " Sending key %d to the console\n", ev.key);
+	usb_log_debug2(NAME " Sending key %d to the console", ev.key);
 	if (multim_dev->console_sess == NULL) {
 		usb_log_warning(
@@ -149,5 +149,5 @@
 		async_exchange_end(exch);
 	} else {
-		usb_log_warning("Failed to send multimedia key.\n");
+		usb_log_warning("Failed to send multimedia key.");
 	}
 }
@@ -159,5 +159,5 @@
 	}
 
-	usb_log_debug(NAME " Initializing HID/multimedia structure...\n");
+	usb_log_debug(NAME " Initializing HID/multimedia structure...");
 
 	/* Create the exposed function. */
@@ -165,5 +165,5 @@
 	    hid_dev->usb_dev, fun_exposed, NAME);
 	if (fun == NULL) {
-		usb_log_error("Could not create DDF function node.\n");
+		usb_log_error("Could not create DDF function node.");
 		return ENOMEM;
 	}
@@ -184,5 +184,5 @@
 	errno_t rc = ddf_fun_bind(fun);
 	if (rc != EOK) {
-		usb_log_error("Could not bind DDF function: %s.\n",
+		usb_log_error("Could not bind DDF function: %s.",
 		    str_error(rc));
 		ddf_fun_destroy(fun);
@@ -190,5 +190,5 @@
 	}
 
-	usb_log_debug(NAME " function created (handle: %" PRIun ").\n",
+	usb_log_debug(NAME " function created (handle: %" PRIun ").",
 	    ddf_fun_get_handle(fun));
 
@@ -199,5 +199,5 @@
 		    str_error(rc));
 		if (ddf_fun_unbind(fun) != EOK) {
-			usb_log_error("Failed to unbind %s, won't destroy.\n",
+			usb_log_error("Failed to unbind %s, won't destroy.",
 			    ddf_fun_get_name(fun));
 		} else {
@@ -210,5 +210,5 @@
 	*data = fun;
 
-	usb_log_debug(NAME " HID/multimedia structure initialized.\n");
+	usb_log_debug(NAME " HID/multimedia structure initialized.");
 	return EOK;
 }
@@ -224,8 +224,8 @@
 		async_hangup(multim_dev->console_sess);
 	if (ddf_fun_unbind(fun) != EOK) {
-		usb_log_error("Failed to unbind %s, won't destroy.\n",
+		usb_log_error("Failed to unbind %s, won't destroy.",
 		    ddf_fun_get_name(fun));
 	} else {
-		usb_log_debug2("%s unbound.\n", ddf_fun_get_name(fun));
+		usb_log_debug2("%s unbound.", ddf_fun_get_name(fun));
 		/* This frees multim_dev too as it was stored in
 		 * fun->data */
@@ -266,5 +266,5 @@
 	while (field != NULL) {
 		if (field->value != 0) {
-			usb_log_debug(NAME " KEY VALUE(%X) USAGE(%X)\n",
+			usb_log_debug(NAME " KEY VALUE(%X) USAGE(%X)",
 			    field->value, field->usage);
 			const unsigned key =
@@ -272,5 +272,5 @@
 			const char *key_str =
 			    usbhid_multimedia_usage_to_str(field->usage);
-			usb_log_info("Pressed key: %s\n", key_str);
+			usb_log_info("Pressed key: %s", key_str);
 			usb_multimedia_push_ev(multim_dev, KEY_PRESS, key);
 		}
